'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Provider = exports.Consumer = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _hammerjs = require('hammerjs');

var _v = require('uuid/v4');

var _v2 = _interopRequireDefault(_v);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Context = _react2.default.createContext(false);

var getComponentName = function getComponentName(Component) {
  return Component.displayName || Component.name;
};

var GestureProvider = function (_React$Component) {
  _inherits(GestureProvider, _React$Component);

  function GestureProvider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GestureProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GestureProvider.__proto__ || Object.getPrototypeOf(GestureProvider)).call.apply(_ref, [this].concat(args))), _this), _this.hammer = false, _this.startupRecognizers = [], _this.startupHandlers = [], _this.setChildRef = function (ref) {
      _this.child = ref;
    }, _this.getContext = function () {
      return {
        addRecognizer: _this.addRecognizer,
        on: _this.onEvent,
        off: _this.offEvent,
        removeRecognizer: _this.removeRecognizer
      };
    }, _this.addRecognizer = function (RecognizerClass) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var recognizeWith = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var requireFailure = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

      var id = (0, _v2.default)();
      options = _extends({}, options, {
        event: id
      });

      if (!_this.hammer) {
        _this.startupRecognizers.push([RecognizerClass, options, recognizeWith, requireFailure]);

        return id;
      }

      var recognizer = new RecognizerClass(options);

      if (recognizeWith) {
        recognizeWith.forEach(function (recWith) {
          return recognizer.recognizeWith(recWith);
        });
      }

      if (requireFailure) {
        requireFailure.forEach(function (recFailure) {
          return recognizer.requireFailure(recFailure);
        });
      }

      _this.hammer.add(recognizer);

      return id;
    }, _this.onEvent = function (event, eventHandler) {
      if (!_this.hammer) {
        _this.startupHandlers.push({ event: event, eventHandler: eventHandler });

        return;
      }

      _this.hammer.on(event, eventHandler);
    }, _this.offEvent = function (event, eventHandler) {
      if (!_this.hammer) {
        if (eventHandler) {
          _this.startupHandlers = _this.startupHandlers.filter(function (handler) {
            return !(handler.event === event && handler.eventHandler === eventHandler);
          });
        } else {
          _this.startupHandlers = _this.startupHandlers.filter(function (handler) {
            return handler.event !== event;
          });
        }

        return;
      }

      _this.hammer.off(event, eventHandler);
    }, _this.removeRecognizer = function (id) {
      if (!_this.hammer) {
        _this.startupRecognizers = _this.startupRecognizers.filter(function (recognizer) {
          return recognizer[1].event !== id;
        });

        return;
      }

      _this.hammer.remove(id);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GestureProvider, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      (0, _invariant2.default)(this.child, 'Please use the function \'setWithGestureRef\' passed ' + 'to your component your consumer function to set a reference ' + 'to the component which withGestures should detect gestures for.');

      this.hammer = new _hammerjs.Manager(this.child, {
        touchAction: 'compute',
        recognizers: this.startupRecognizers
      });

      this.startupHandlers.forEach(function (_ref2) {
        var event = _ref2.event,
            eventHandler = _ref2.eventHandler;

        _this2.hammer.on(event, eventHandler);
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.hammer.stop(true);
      this.hammer.destroy();
      this.hammer = false;
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;


      (0, _invariant2.default)(typeof children === 'function', 'Please provide a function as the ' + 'child of the GestureProvider, which will receive the setWithGestureRef function.');

      return _react2.default.createElement(
        Context.Provider,
        { value: this.getContext() },
        children(this.setChildRef)
      );
    }
  }]);

  return GestureProvider;
}(_react2.default.Component);

exports.default = GestureProvider;
var Consumer = exports.Consumer = Context.Consumer;
var Provider = exports.Provider = Context.Provider;