"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.callIfDefined = callIfDefined;
exports.createPropWhiteLister = createPropWhiteLister;
exports.createAreShallowEqual = createAreShallowEqual;
exports.createDidChange = createDidChange;
function callIfDefined(fnc) {
  for (var _len = arguments.length, props = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    props[_key - 1] = arguments[_key];
  }

  return fnc && fnc.apply(undefined, props);
}

function createPropWhiteLister(whiteList) {
  return function (obj) {
    return whiteList.reduce(function (result, key) {
      result[key] = obj[key];

      return result;
    }, {});
  };
}

function createAreShallowEqual() {
  var excludedKeys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  return function areShallowEqual(a, b) {
    var aKeys = Object.keys(a);
    return aKeys.length === Object.keys(b).length && aKeys.reduce(function (res, key) {
      return res && (excludedKeys.includes(key) || a[key] === b[key]);
    }, true);
  };
}
var areShallowEqual = exports.areShallowEqual = createAreShallowEqual();

function createDidChange(compareFnc, initialValue) {
  var lastValue = initialValue;

  return function (value) {
    if (!compareFnc(lastValue, value)) {
      lastValue = value;

      return true;
    }

    return false;
  };
}